The Coq developments in this repository depend on both stdpp and VST, but VST
has a notation precedence conflict with stdpp. I ultimately resolved this by
just vendoring VST to have the same precedence. As such, it is necessary to use
the version in the `deps/` directory.

The only external dependencies necessary should be `opam`, `m4`, and
`findutils`, all of which should be available, for example, in the repositories
of most major Linux distributions. With these installed, you can set up the
environment as follows (making sure you have plenty of CPU and RAM!):
```
# in the top-level directory of the repository
opam switch create . --empty
opam repo add coq-released https://coq.inria.fr/opam/released
opam repo add iris-dev https://gitlab.mpi-sws.org/iris/opam.git
opam switch import deps/opam_pkgs

# in deps/CompCert-3.5/
# The development does assume a 64-bit platform. However, it should hopefully
# be okay to change 'linux'.
./configure -clightgen x86_64-linux
make -j3

# in deps/vst/
echo BITSIZE=64 > CONFIGURE
make -j3 depend
make -j3 floyd
```

To build the projects, you can use the following commands. On success, there
will be no output; this means that everything typechecked and the proofs went
through of the theorems as stated.
```
# in pe2/coq/
../../deps/CompCert-3.5/clightgen -normalize -DCOMPCERT CPE2.c
for v in Common.v PE2.v Transmission.v CPE2.v verif_CPE2.v; do coqc $(cat _CoqProject) $v; done

# in optics/coq/
../../deps/CompCert-3.5/clightgen -normalize -DCOMPCERT tree.c
for v in Optics.v tree.v VSTOptics.v; do coqc $(cat _CoqProject) $v; done
```

