#include <stdlib.h>
#include <string.h>
#include <stdio.h>

typedef struct Term {
    enum TermClass {
        LINK, UNIT, COUNIT, TENS, PAR,
    } class;
    /* TODO
     * Figure out what to do in full PE_2, where using a union is probably
     * desirable. */
    struct Term *fst, *snd;
} Term, *Node, **Nodes;


/* ty VST */
void *surely_malloc (size_t n) {
    void *p = malloc(n);
    if (!p) exit(1);
    return p;
}

#define ALLOC(var) Node var = surely_malloc(sizeof(Term))
#define NEW(var, cl) ALLOC(var); var->class = (cl); \
    var->fst = NULL; var->snd = NULL

void free_rec(Node t) {
    if (t == NULL) return;
    switch (t->class) {
        case LINK: case UNIT: case COUNIT: break;
        case TENS: case PAR: free_rec(t->fst); free_rec(t->snd); break;
    }
    free(t);
}

/* constructors */

void mklink(Node *a, Node *b) {
    NEW(x, LINK); NEW(y, LINK);
    x->fst = y;
    y->fst = x;
    *a = x, *b = y;
}
#define NU(x, y) Node x, y; mklink(&x, &y)
#define NU_(x) NU(x, x##_)
Node unit() { NEW(t, UNIT); return t; }
Node counit() { NEW(t, COUNIT); return t; }
Node tens(Node l, Node r) {
    NEW(t, TENS);
    t->fst = l;
    t->snd = r;
    return t;
}
Node par(Node l, Node r) {
    NEW(t, PAR);
    t->fst = l;
    t->snd = r;
    return t;
}


void copy1(Node a, Node b) {
    a->class = b->class;
    a->fst = b->fst;
    a->snd = b->snd;
}
/* TODO rewrite in accordance with VST restrictions */
void cut(Node t, Node u) {
    int t_cl = t->class, u_cl = u->class;
    if (t_cl == LINK || u_cl == LINK) {
        if (t_cl == LINK) copy1(t->fst, u);
        if (u_cl == LINK) copy1(u->fst, t);
        free(t); free(u);
        return;
    }
    else {
        Node t_f = t->fst, t_s = t->snd, u_f = u->fst, u_s = u->snd;
        free(t); free(u);
        switch (t_cl) {
            case LINK: case UNIT: case COUNIT:
                break;
            case TENS:
                cut(t_f, u_f); cut(t_s, u_s);
                break;
            case PAR:
                cut(u_f, t_f); cut(u_s, t_s);
                break;
        }
        return;
    }
}


void print_nodes(int len, Nodes a);
void print_node_prec(int prec, Node t) {
#define P(prec_, block) {if (prec > prec_) printf("("); \
    block; if (prec > prec_) printf(")");}
    switch (t->class) {
        case LINK:
            printf("%p", (void*) ((size_t) t <= (size_t) t->fst ? t : t->fst));
            break;
        case UNIT: printf("*"); break;
        case COUNIT: printf("(*)"); break;
        case TENS: P(5, {print_node_prec(6, t->fst);
                             printf(" ⊗ ");
                             print_node_prec(5, t->snd);}); break;
        case PAR: P(4, {print_node_prec(5, t->fst);
                          printf(" ⅋ ");
                          print_node_prec(4, t->snd);}); break;
    }
}
void print_node(Node t) {print_node_prec(-1, t);}

void print_nodes(int len, Nodes a) {
    for (int i = 0; i < len; i++) {
        print_node(a[i]);
        if (i + 1 < len) printf(", ");
    }
}


Node main_(Nodes clos);
/* paste code here generated by "putStrLn . compileToC $ somePrfExp" with
 * PE2.hs loaded, where somePrfExp :: PrfExp and has exactly 1 term in its main
 * body (if your top-level program has multiple terms in its main body, put
 * them into a big ⅋) */
/* end generated code */


int main(void) {
    Node a = main_(NULL);
    print_node(a); printf("\n");
    /* print_fw(a); printf("\n"); */
    /* printf("%d\n", unchurch(a)); */
    free_rec(a);
    return 0;
}

